ECScreen nav;
ECScreen abc;
ECScreen numbers;
ECScreen settings;
ECScreen file;

ArduinoUSB flexSensor;
PImage icon;            //icon for program displayed in taskbar
Notifier not1;



color background = #BBBBBB;
boolean darkMode = false;
boolean liveCam = true;

Frame frame;
MultilineTextBox mlineText;
TextView textview;
Button closeButton;


void setupVisuals() {


  //setting up the pgui
  {
    frame = new Frame();
    mlineText = new MultilineTextBox();
    textview = new TextView(width/3 + 10);
    closeButton = new Button();

    mlineText.FontSize = 15;
    mlineText.paddingBottom = 10;
    mlineText.paddingLeft = 10;
    mlineText.paddingRight = 10;
    mlineText.paddingTop = 10;
    mlineText.setSize(width/3 + 5, height/3 + 5);
    mlineText.X = width/3 - 5;
    mlineText.Y = height/3;
    mlineText.VisualBackgroundColor = color(40, 0, 0, 100);
    mlineText.BorderWidth = 1;
    mlineText.scrollSpeed = 20;

    textview.X = width/3-4;
    textview.Y = 2 * height/3 + 5;
    textview.setFontSize(mlineText.FontSize);
    textview.Transparent = false;
    textview.VisualBackgroundColor = color(0, 50);

    closeButton.setText("x");
    closeButton.setSize(40, 25);
    closeButton.X = width-40;
    closeButton.setBackgroundColor(color(180, 130, 130));
    closeButton.ForegroundColor = 255;
    closeButton.FontSize = (17);
    closeButton.addMouseListener("closeBtnPressed");
    closeButton.Y = -2;


    frame.setSize(width, height);
    frame.Name = "FRAME";
    frame.add(mlineText);
    frame.VisualBackgroundColor = color(0, 0);
    frame.add(textview);
    frame.add(closeButton);

    frame.setParentFrame();
    frame.addKeyEventListener();
    mlineText.Focus();
  }




  setupECScreens();


  flexSensor = new ArduinoUSB(this, not1);
  flexSensor.printPortList();
  flexSensor.setPort(0);

  not1 = new Notifier(250, 60);


  textSize(60);
  frameRate(10);
}

void setupECScreens() {
  try {
    icon = loadImage("icon-image.png");
    surface.setIcon(icon);
    surface.setTitle("iContact");
    nav = new ECScreen("Screens\\nav.txt", 0, 50);
    abc = new ECScreen("Screens\\abc.txt", 1, 50);
    numbers = new ECScreen("Screens\\numbers.txt", 2, 50);
    settings = new ECScreen("Screens\\settings.txt", 3, 40);
    file = new ECScreen("Screens\\file.txt", 4, 40);
  } 
  catch (Exception e) {
    e.printStackTrace();
  }
  ECScreenConstants.setActiveScreen(0);
}




/*
 * Main draw() method for this part of the program
 */
void drawVisuals() {
  background(background);

  //drawing the currently active screen
  ECScreenConstants.drawScreen();
  
  //evaluate the movements of the mouse thus simulating the eye tracking to test the progran
  evaluateMouseMovement();

  //invert image if dark mode has been enabled
  if (darkMode) {
    filter(INVERT);
  }
}



//track mouse wheel changes to scroll the textbox, actually not needed anymore with the update of my GUI-library but not implemented yet in this project
void mouseWheel(MouseEvent event) {
  float e = event.getCount();

  //if focused a scroll container, scroll it
  if (frame.FocusedElement instanceof VScrollContainer) {
    println("hovered over VSC");
    ((VScrollContainer) frame.FocusedElement).addToScrollPositionY(e);
  } else if (frame.FocusedElement instanceof HScrollContainer) {
    println("hovered over VSC");
    ((HScrollContainer) frame.FocusedElement).addToScrollPositionX(e);
  }
}


//exit when close button is hit
void closeBtnPressed() {
  exit();
}
