


int previousDir = 4;
String outputString = "";
boolean  caps = false;
void interpretEyeData(int dir, boolean mouseIsPressed) { 

  switch(ECScreenConstants.getActiveScreenId()) { //interpreting differs from screen to screen
  case 0: //NAVIGATION SCHREEN
    eyeDataNav(dir, mouseIsPressed);
    break;
  case 1: //ABC SCREEN
    eyeDataABC(dir, mouseIsPressed);
    break;
  case 2: //NUMBER SCREEN
    eyeDataNumbers(dir, mouseIsPressed);
    break;
  case 3: //SETTINGS SCREEN
    eyeDataSettings(dir, mouseIsPressed);
    break;
  case 4: //FILE MANAGING SCREEN
    break;
  }
}

char interpreterNUMBERS[][] = {
  {0, '2', 0, '1', 0, '3', 0, '4', 0 }, 
  {0, '6', 0, '5', 0, '7', 0, '8', 0 }, 
  {0, '0', 0, '9', 0, '!', 0, '?', 0 }, 
  {0, 0, 0, 0, 0, 0, 0, 0, 0 }, 
  {0, 0, 0, 0, 0, 0, 0, 0, 0 }, 
  {0, 0, 0, 0, 0, 0, 0, 0, 0 }, 
  {0, '@', 0, '/', 0, '\\', 0, '#', 0 }, 
  {0, '=', 0, '+', 0, '-', 0, '\'', 0 }, 
  {0, '.', 0, ':', 0, ';', 0, ',', 0 }
};
char interpreterABC[][] = {
  {0, 'b', 0, 'a', 0, 'c', 0, 'd', 0 }, 
  {0, 'f', 0, 'e', 0, 'g', 0, 'h', 0 }, 
  {0, 'j', 0, 'i', 0, 'k', 0, 'l', 0 }, 
  {0, 0, 0, 0, 0, 0, 0, 0, 0 }, 
  {0, 0, 0, 0, 0, 0, 0, 0, 0 }, 
  {0, 0, 0, 0, 0, 0, 0, 0, 0 }, 
  {0, 'n', 0, 'm', 0, 'o', ',', 'p', '.' }, 
  {0, 'r', 0, 'q', 0, 's', 0, 't', 0 }, 
  {0, 'v', 0, 'u', 0, 'w', 'y', 'x', 'z'}
};


void eyeDataNav(int dir, boolean mouseWasPressed) {
  if (mouseWasPressed) { //only when pressed change screen (select-press mode);
    switch(dir) {
    case 0:
      ECScreenConstants.setActiveScreen(1); 
      break; //ABC Screen
    case 1: 
      ECScreenConstants.setActiveScreen(3); 
      break; //Settings Screen
    case 3: 
      ECScreenConstants.setActiveScreen(2); 
      break; //Numbers Screen
    case 4:
      ECScreenConstants.setActiveScreen(5); 
      break; //Commands Screen (non-existent)
    case 6:
      ECScreenConstants.setActiveScreen(4); 
      break; //File Screen
    }
    previousDir = 4;
  }
}

void eyeDataABC(int dir, boolean mouseWasPressed) {
  if (mouseWasPressed) {
    switch(dir) {
    case 5:       //right -> Space
      outputString += " ";
      textview.append(" ");
      mlineText.append(" ");
      break;
    case 3:       //left -> Delete
      if (outputString.length() > 0)
        outputString = outputString.substring(0, outputString.length()-1);
      textview.deleteAtCursor();
      mlineText.backspace();
      break;
    case 1:       //top -> Capital letter
      caps = true;
      break;
    case 7:       //bottom -> Return
      outputString += "\n";
      textview.append(" ");
      mlineText.append("\n");
      break;
    }
    previousDir = 4;
  } else { //mouse was not pressed
    if (previousDir != 4 && dir != 4) { //both not center
      String add = str(interpreterABC[previousDir][dir]);
      if (!add.equals("\0")) { //check if character had a value other than 0
        outputString += caps? add.toUpperCase() : add;
        textview.append(caps? add.toUpperCase() : add);
        mlineText.append(caps? add.toUpperCase() : add);
        caps = false;
      }
      previousDir = 4;
    } else if (previousDir != 4 && dir == 4 || dir == 3 || dir == 5) { //don't overwrite previousDir when direction is not suitable
    } else {
      previousDir = dir;
    }
  }
}

void eyeDataNumbers(int dir, boolean mouseIsPressed) {
  if (mouseIsPressed) {
    switch(dir) {
    case 5:       //right -> Space
      outputString += " ";
      textview.append(" ");
      mlineText.append(" ");
      break;
    case 3:       //left -> Delete
      if (outputString.length() > 0)
        outputString = outputString.substring(0, outputString.length()-1);
      textview.deleteAtCursor();
      mlineText.backspace();
      break;
    case 1:       //top -> Capital letter
      caps = true;
      break;
    case 7:       //bottom -> Return
      outputString += "\n";
      textview.append(" ");
      mlineText.append("\n");
      break;
    }
    previousDir = 4;
  } else { //mouse was not pressed
    if (previousDir != 4 && dir != 4) { //both not center
      String add = str(interpreterNUMBERS[previousDir][dir]);
      if (!add.equals("\0")) { //check if character had a value other than 0
        outputString += add;
        textview.append(add);
      }
      previousDir = 4;
    } else if (previousDir != 4 && dir == 4 || dir == 3 || dir == 5) { //don't overwrite previousDir when direction is not suitable
    } else {
      previousDir = dir;
    }
  }
}

void eyeDataSettings(int dir, boolean mouseIsPressed){
  if (mouseIsPressed) { //only when pressed change screen (select-press mode);
      switch(dir) {
      case 0: //recalibrate sensor
        if (flexSensor.initialized) {
          flexSensor.recalibrate();
        } else {
          not1.setNotification("No sensor connected", 1000);
        }
        break; 
      case 1: //hide/show live cam
        liveCam = !liveCam;
        break; 
      case 2: //light/dark mode
        darkMode = !darkMode;
        if (darkMode) {
          not1.setNotification("Changed to dark mode", 1000);
        } else {
          not1.setNotification("Changed to light mode", 1000);
        }
        break;
      case 3: //sleep/wake sensor
        flexSensor.sleep();
        not1.setNotification("Set Sensor to sleep", 1000);
        break; 
      case 4:
        break; 
      case 6:
        break;
      case 8: //close application
        exit();
        break;
      }
      previousDir = 4;
    }
}
