/* Im Moment bereiten wir uns darauf vor, unsere zwei Hauptprojekte: 
      - Die Grafische Oberfläche mit Implementierung des Arduino
      - Die Augen- und Iriserkennung mit den Grafik-Algorithmen, eigener Kalibrierungsphase und Auswertungsalgorithmen
   zu vereinigen. 
   Da allerdings die Teile sehr verschieden aufgebaut sind und einige Methoden (wie setup(), draw(), und die Maus, und Tastatur-Events) teilen müssen
   ist dies ein recht aufwendiger Process, bei dem viele neue Fehler entstehen. Diese Phase sollte nächste Woche allerdings abgeschlossen sein. 
   
   
   
   
   - Die erste Datei "A_Visuls" initialisiert die graphischen Komponenten und die Instanzen für den Arduino-Handler und die Hintergrund-Screens. 
   
   - "ArduinoUSB" ist die Arduino-Kommunikations-Klasse. Sie überprüft, ob Nachrichten vom Arduino eingetroffen sind und ruft entsprechende Aktionen auf. 
   - "Control" ist der Tab für die Event-Methoden die es ermöglichen das Programm auch mit der Maus und Tastatur zu steuern, nicht nur wie geplant mit den Augen
   - "ECScreen" - alias Eye Control Screen ist die Klasse für die Hintergründe, die anzeigen, wie die Augen zu bewegen sind, um eine Eingabe zu tätigen. 
     Die Anweisungen für die Darstellung sind im Data-Ordner unter screens. Für jeden Screen eine einzelne Datei - mit Koordinaten, Textinhalt, Farben etc. 
   - In "Evaluation" werden die Daten von Maus (und bald Augenerkennung) interpretiert und entsprechend des aktiven Screens ausgeführt.
   - "Notifier" enhält die gleichnamige Klasse, die zum Darstellen von popup-Benachrichtugnen, bei Fehlern mit dem Sensor o.ä. warnt.
   
   - Die restlichen Dateien enthalten eine ausgewählte Sammlung von den Klassen aus der GUI_Library, von Kyano geschrieben und die neue Multiline-Textbox, in der der eingegebene Text
     dargestellt wird. 
       
   Die Library wurde bereits als .jar verpackt und testweise erfolgreich eingebunden, wird aber von uns zurzeit noch auf Fehler überprüft. 
   Sie ist ebenfalls im Ordner enthalten
   
   */
   
   

void setup() {
  fullScreen();
  setupVisuals();
}


//should be set to true when the tracking process has begun (after calibration has finished)
//while calibration the screens shouldn't be displayed
boolean tracking = true;


void draw() {
  if (tracking) {
    drawVisuals();
  }
}
